<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow  xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   xmlns:componente="br.com.desenv.framework.componente.*"
			   close="titlewindowCloseHandler(event)"  
			   creationComplete="creationCompleteHandler(event)" 
			   title="Cadastro de Log Produtos Sem Ncm"
			  maxWidth="1200" maxHeight="700"  
			   xmlns:visual="br.com.desenv.framework.component.visual.*"   xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
			   
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	
	<fx:Metadata>
		[Event(name="LogprodutossemncmIncluidoEvent")]
		[Event(name="LogprodutossemncmAtualizadoEvent")]
		[Event(name="LogprodutossemncmExcluidoEvent")]
		[Event(name="LogprodutossemncmSelecionadoEvent")]
		
	</fx:Metadata>

	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.validators.Validator;
			import spark.events.TitleWindowBoundsEvent;
			
			import br.com.desenv.nepalign.vo.Logprodutossemncm;
			
			// Alguem passa a objeto para ca
			public var logprodutossemncm : Logprodutossemncm = new Logprodutossemncm();
			

			
			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}
			
			private function limparListaCampo(): void
			{
				ignTextInputIntegerProduto.text = "";
				ignTextInputNcmAntigo.text = "";
				ignTextInputNcmNovo.text = "";
				ignTextInputDateDataLog.text = "";
				ignTextInputIntegerEmpresa.text = "";
				ignTextInputIntegerNotaFiscal.text = "";
				ignTextInputObservacao.text = "";
			}
			
			// Chama ao completar o carregamento da pagina
			private function creationCompleteHandler( event: FlexEvent ): void 
			{
				carregarListaValidacao();
				
				
				// Se e um novo cadastro
				if (isNaN(this.logprodutossemncm.id))
				{
					limparListaCampo();
				}
				// Se alguem passou o objeto
				else
				{
					ignTextInputIntegerProduto.text = this.logprodutossemncm.produto.toString();

					ignTextInputNcmAntigo.text = this.logprodutossemncm.ncmAntigo;

					ignTextInputNcmNovo.text = this.logprodutossemncm.ncmNovo;

					ignTextInputDateDataLog.text = DateField.dateToString(this.logprodutossemncm.dataLog, "DD/MM/YYYY"); 

					ignTextInputIntegerEmpresa.text = this.logprodutossemncm.empresa.toString();

					ignTextInputIntegerNotaFiscal.text = this.logprodutossemncm.notaFiscal.toString();

					ignTextInputObservacao.text = this.logprodutossemncm.observacao;

				}
			}
			
			
			
			
			// Chama quando fecha a janela no X
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- SALVAR E ATUALIZAR  --------------------------------	
			private function buttonSalvar_clickHandler( event: MouseEvent ): void 
			{
				if (validar(event))
				{
					// Se e alteracao
					if (isNaN(logprodutossemncm.id) == false) 
					{
						logprodutossemncm.produto =  ignTextInputIntegerProduto.text == ""?NaN:parseInt(ignTextInputIntegerProduto.text);
						logprodutossemncm.ncmAntigo = ignTextInputNcmAntigo.text;
						logprodutossemncm.ncmNovo = ignTextInputNcmNovo.text;
						logprodutossemncm.dataLog = ignTextInputDateDataLog.text == ""?null:DateField.stringToDate(ignTextInputDateDataLog.text, "DD/MM/YYYY");
						logprodutossemncm.empresa =  ignTextInputIntegerEmpresa.text == ""?NaN:parseInt(ignTextInputIntegerEmpresa.text);
						logprodutossemncm.notaFiscal =  ignTextInputIntegerNotaFiscal.text == ""?NaN:parseInt(ignTextInputIntegerNotaFiscal.text);
						logprodutossemncm.observacao = ignTextInputObservacao.text;
						var remoteObjectAtualizar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("logprodutossemncmService", atualizarResultHandler);	
						remoteObjectAtualizar.getOperation("atualizar").send(logprodutossemncm); 
					// Se e inclusao
					} 
					else 
					{
						logprodutossemncm.produto =  ignTextInputIntegerProduto.text == ""?NaN:parseInt(ignTextInputIntegerProduto.text);

						logprodutossemncm.ncmAntigo = ignTextInputNcmAntigo.text;

						logprodutossemncm.ncmNovo = ignTextInputNcmNovo.text;

						logprodutossemncm.dataLog = ignTextInputDateDataLog.text == ""?null:DateField.stringToDate(ignTextInputDateDataLog.text, "DD/MM/YYYY");

						logprodutossemncm.empresa =  ignTextInputIntegerEmpresa.text == ""?NaN:parseInt(ignTextInputIntegerEmpresa.text);

						logprodutossemncm.notaFiscal =  ignTextInputIntegerNotaFiscal.text == ""?NaN:parseInt(ignTextInputIntegerNotaFiscal.text);

						logprodutossemncm.observacao = ignTextInputObservacao.text;

						var remoteObjectSalvar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("logprodutossemncmService", salvarResultHandler);	
						remoteObjectSalvar.getOperation("salvar").send(logprodutossemncm); 
					}
				}	
			}

			
			// Depois que salva fecha a janela
			private function salvarResultHandler( event: ResultEvent ): void 
			{
				this.logprodutossemncm = event.result as Logprodutossemncm;
				this.dispatchEvent(new ResultEvent("LogprodutossemncmIncluidoEvent",false, true, this.logprodutossemncm, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			// Depois que atualiza fecha a janela
			private function atualizarResultHandler( event: ResultEvent ): void 
			{
				this.logprodutossemncm = event.result as Logprodutossemncm;
				this.dispatchEvent(new Event("LogprodutossemncmAtualizadoEvent"));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- LIMPAR  --------------------------------	
			protected function buttonLimpar_clickHandler(event:MouseEvent):void
			{
				limparListaCampo();
			}
						
// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				

			
// ---------------------------------- PESQUISAR AUTOR ABRINDO A LISTA  --------------------------------				
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<!-- <mx:Validator id="validatorObrigatorioSituacaoLogprodutossemncm" property="selectedItem" required="true" source="{comboBoxSituacaoLogprodutossemncm}" trigger="{comboBoxSituacaoLogprodutossemncm}" triggerEvent="valueCommit"/> -->
		

		<s:ArrayCollection id="listaOpcaoSimNao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Nao"/>
		</s:ArrayCollection>
					
	</fx:Declarations>
	

	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="720" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Produto:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoProduto" styleName="labelValidacao"  text="{ignTextInputIntegerProduto.errorString}"/>
					<visual:IgnTextInputInteger id="ignTextInputIntegerProduto" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>

			<mx:GridItem styleName="gridLabel">
				<s:Label text="NcmAntigo:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoNcmAntigo" styleName="labelValidacao" text="{ignTextInputNcmAntigo.errorString}"/>
					<visual:IgnTextInput id="ignTextInputNcmAntigo" maxChars="45" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="NcmNovo:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoNcmNovo" styleName="labelValidacao" text="{ignTextInputNcmNovo.errorString}"/>
					<visual:IgnTextInput id="ignTextInputNcmNovo" maxChars="45" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="DataLog:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDataLog" styleName="labelValidacao" text="{ignTextInputDateDataLog.errorString}"/>
					<visual:IgnTextInputDate id="ignTextInputDateDataLog" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Empresa:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoEmpresa" styleName="labelValidacao"  text="{ignTextInputIntegerEmpresa.errorString}"/>
					<visual:IgnTextInputInteger id="ignTextInputIntegerEmpresa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>

			<mx:GridItem styleName="gridLabel">
				<s:Label text="Nota Fiscal:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoNotaFiscal" styleName="labelValidacao"  text="{ignTextInputIntegerNotaFiscal.errorString}"/>
					<visual:IgnTextInputInteger id="ignTextInputIntegerNotaFiscal" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>

		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Obervação:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoObservacao" styleName="labelValidacao" text="{ignTextInputObservacao.errorString}"/>
					<visual:IgnTextInput id="ignTextInputObservacao" maxChars="100" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>



 			<mx:GridItem colSpan="2">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Button id="buttonSalvar" label="Salvar" click="buttonSalvar_clickHandler(event)"/>
				<s:Button id="buttonLimpar" label="Limpar" click="buttonLimpar_clickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>
</s:TitleWindow>